DECLARE SUB lose ()
DECLARE SUB INTRO ()
DECLARE SUB message ()
DECLARE SUB first (Speed)
DECLARE SUB win ()
DECLARE SUB about ()
DECLARE SUB logo ()
DECLARE SUB ENDer ()
DECLARE SUB SBinit ()
DECLARE SUB CloseChannels ()
DECLARE SUB PLAYMUSiC ()
DECLARE SUB SetIns (Channel%)
DECLARE SUB WriteReg (Reg%, value%)
DECLARE SUB TimePause ()
DECLARE FUNCTION LoadJamFile% (File$)


'$DYNAMIC  ' We have to resize the Song Buffer when loading


CONST BasePort% = &H220  ' Change this for other sound cards.


DIM SHARED MaxChannel%, MaxNotes%

CONST MaxPlay% = -1

' Instrument-type.  For your convenience, use the MKJamz Instrument Creator.
' After all, that's what it's there for.
TYPE InsType
 MMult AS INTEGER     ' Modulator's Multiple
 MLevel AS INTEGER    ' Modulator's Level
 MAttack AS INTEGER   ' Modulator's Attack
 MSustain AS INTEGER  ' Modulator's Sustain
 CMult AS INTEGER     ' Carrier's Multiple
 CLevel AS INTEGER    ' Carrier's Level
 CAttack AS INTEGER   ' Carrier's Attack
 CSustain AS INTEGER  ' Carrier's Sustain
END TYPE


' This template holds the current channel information.
TYPE ChannelType
 Defined AS INTEGER   ' Has the user defined the channel and it's notes? (1 if yes)
 Speed AS SINGLE      ' The duration of each note
 SongPtr AS INTEGER   ' A pointer to the current song position
 PStat AS SINGLE      ' Pause counter 2
 Octave AS INTEGER    ' The Octave of each channel
 WaveForm AS INTEGER  ' The Wave Form of each channel
 Flag AS INTEGER      ' Misc control flag
 Flag2 AS INTEGER     ' Number of times to play song
 IsPlaying AS INTEGER ' Is a note playing (1=yes)
 IsDone AS INTEGER    ' Has the note stopped? (1=yes)
END TYPE



DIM SHARED ChannelStat(1 TO 2) AS ChannelType ' We will resize this when
                                              ' loading a MK Jamz file.

DIM SHARED SongBuf(1 TO 2) AS INTEGER ' We will resize this when loading
                                      ' a MK Jamz file.

DIM SHARED CurrentIns AS InsType ' We use this buffer for loading and setting FM
                                 ' instrument types.


REM I plan on putting in sound blaster music as soon as possible
REM Is the game to easy or to hard?
level% = 0
first Speed
logo

SCREEN 12

start:
SBinit
CLOSE
CLS
DIM byte AS STRING * 1
CLS
'INPUT "Bitmap Filename"; data$

data$ = "blaze.bmp"

IF LTRIM$(RTRIM$(data$)) = "" THEN END
OPEN data$ FOR BINARY AS #1
IF LOF(1) = 0 THEN PRINT "File not found!": CLOSE : KILL data$: END

table$ = INPUT$(54, #1)  'Get the file header (54 bytes)
REDIM table&(30)           'Create numerical array for header
DEF SEG = VARSEG(table&(1))
pointer% = VARPTR(table&(1))

'Poke the data from string "table$" into numerical array "table&"
FOR x% = 0 TO 51
 POKE pointer% + x%, ASC(MID$(table$, x% + 3, 1))
NEXT
DEF SEG

'Check for valid file type
IF MID$(table$, 1, 2) <> "BM" OR table&(4) <> 40 THEN
   PRINT "Not a valid *.BMP file!": END
END IF
IF table&(8) <> 0 THEN
   PRINT "This program will not diplay RLE encoded files": END
END IF
'IF ASC(MID$(table$, 29, 1)) <> 4 THEN
'   PRINT "Only 16 color bitmaps are supported!": END
'END IF

'Set the video mode for best picture fit
IF (table&(5) < 321) AND (table&(6) < 201) THEN
   SCREEN 12
ELSE
   SCREEN 12
END IF
LOCATE 2, 1


thecolors$ = INPUT$(table&(3) - 54, #1) 'Read in pallette info

DEF SEG = VARSEG(pal&)
pointer% = VARPTR(pal&)
'Poke the pallette info from the string "thecolors$"
'into pal& and reduce to 6 bits per byte.
FOR x% = 0 TO 63 STEP 4
 POKE pointer%, (ASC(MID$(thecolors$, x% + 3, 1))) \ 4
 POKE pointer% + 1, (ASC(MID$(thecolors$, x% + 2, 1))) \ 4
 POKE pointer% + 2, (ASC(MID$(thecolors$, x% + 1, 1))) \ 4
 POKE pointer% + 3, 0
PALETTE x% \ 4, pal&
NEXT
DEF SEG



'Read in Bitmap data and set pixels accordingly
y% = table&(6) 'Put number of vertical pixels into y%
DO
  data$ = INPUT$((((table&(5) - 1) OR 7) + 1) \ 2, #1)
    IF (table&(5) \ 2) < LEN(data$) THEN
       linelength% = table&(5) \ 2
    ELSE
       linelength% = LEN(data$)
    END IF
    FOR x% = 1 TO linelength%
      pixel% = ASC(MID$(data$, x%, 1))
      PSET (x% * 2 + 1, y%), pixel% AND 15
      PSET (x% * 2, y%), pixel% \ 16
     NEXT
    y% = y% - 1
LOOP UNTIL EOF(1) 'OR INKEY$ <> ""
CLOSE


loc1 = 1
a = 15
b = 2
109
COLOR 2
LOCATE 22, 33
PRINT "Enter to Select"
COLOR a
LOCATE 23, 33
PRINT "1)Begin Game"
COLOR b
LOCATE 24, 33
PRINT "2)Practice Game"
COLOR c
LOCATE 25, 33
PRINT "3)About"
COLOR d
LOCATE 26, 33
PRINT "4)Exit"
q$ = INKEY$
SELECT CASE q$
CASE CHR$(0) + "P"
loc1 = loc1 + 1
GOTO 119
CASE CHR$(0) + "H"
loc1 = loc1 - 1
GOTO 119
CASE CHR$(13)
GOTO 139
END SELECT
119
IF loc1 < 1 THEN loc1 = 4
IF loc1 > 4 THEN loc1 = 1
IF loc1 = 1 THEN a = 15: b = 2: c = 2: d = 2
IF loc1 = 2 THEN b = 15: a = 2: c = 2: d = 2
IF loc1 = 3 THEN c = 15: b = 2: a = 2: d = 2
IF loc1 = 4 THEN d = 15: b = 2: c = 2: a = 2
GOTO 109
139
IF loc1 = 1 THEN level% = 1: GOTO game:
IF loc1 = 2 THEN GOTO practice:
IF loc1 = 3 THEN about: GOTO start
IF loc1 = 4 THEN ENDer
'RUN "c:\turbo\games.bas"
CLS
GOTO 109
game:
CLS
Filename$ = "blaze.mkj"
'INPUT "MK Jamz Song to load (*.MKJ) : ", FileName$

SBinit

CLS
COLOR 14

LoadStatus% = LoadJamFile(Filename$) ' The load routine is a little different.
                                     ' It's a function that returns various
                                     ' error codes if the load failed.  So
                                     ' we have to store the return code in
                                     ' a variable.  This uses LoadStatus%

IF LoadStatus% <> 1 THEN
  
 SELECT CASE LoadStatus%
   CASE -1: PRINT "File not found!": SYSTEM
   CASE -2: PRINT "Invalid .MKJ file.": SYSTEM
   CASE -3: PRINT "Advanced MKJ file encountered.": SYSTEM
 END SELECT

END IF


CLS
SCREEN 0
SCREEN 12
COLOR 2
1099
COLOR 15
LOCATE 2, 33
PRINT "Ana";
COLOR 1
PRINT "R";
COLOR 15
PRINT "ctic Bla";
COLOR 1
PRINT "Z";
COLOR 15
PRINT "e ";
COLOR 1
PRINT " V 1.1"
COLOR a
LOCATE 5, 33
PRINT "1)Beginner"
COLOR b
LOCATE 6, 33
PRINT "2)Intermediate"
COLOR c
LOCATE 7, 33
PRINT "3)Advanced"
COLOR d
LOCATE 8, 33
PRINT "4)Back to menu"
q$ = INKEY$
SELECT CASE q$
CASE CHR$(0) + "P"
loc1 = loc1 + 1
GOTO 1199
CASE CHR$(0) + "H"
loc1 = loc1 - 1
GOTO 1199
CASE CHR$(13)
GOTO 1399
END SELECT
1199
IF loc1 < 1 THEN loc1 = 4
IF loc1 > 4 THEN loc1 = 1
IF loc1 = 1 THEN a = 15: b = 2: c = 2: d = 2
IF loc1 = 2 THEN b = 15: a = 2: c = 2: d = 2
IF loc1 = 3 THEN c = 15: b = 2: a = 2: d = 2
IF loc1 = 4 THEN d = 15: b = 2: c = 2: a = 2
GOTO 1099
1399
IF loc1 = 1 THEN diffic = 1: GOTO begin:
IF loc1 = 2 THEN diffic = 2: GOTO begin:
IF loc1 = 3 THEN diffic = 3: GOTO begin:
IF loc1 = 4 THEN GOTO start:
CLS
GOTO 1099

practice:
CLS
SCREEN 0
SCREEN 12
10999
COLOR 15
LOCATE 2, 33
PRINT "Ana";
COLOR 1
PRINT "R";
COLOR 15
PRINT "tic Bla";
COLOR 1
PRINT "Z";
COLOR 15
PRINT "e ";
COLOR 1
PRINT " V 1.1"
COLOR a
LOCATE 5, 33
PRINT "Prepare"
COLOR b
LOCATE 6, 36
PRINT "Your"
COLOR c
LOCATE 7, 39
PRINT "Self!"
COLOR d
q$ = INKEY$
SELECT CASE q$
CASE CHR$(0) + "P"
loc1 = loc1 + 1
GOTO 11999
CASE CHR$(0) + "H"
loc1 = loc1 - 1
GOTO 11999
CASE CHR$(13)
GOTO 13999
END SELECT
11999
IF loc1 < 1 THEN loc1 = 4
IF loc1 > 4 THEN loc1 = 1
IF loc1 = 1 THEN a = 15: b = 2: c = 2: d = 2
IF loc1 = 2 THEN b = 15: a = 2: c = 2: d = 2
IF loc1 = 3 THEN c = 15: b = 2: a = 2: d = 2
IF loc1 = 4 THEN d = 15: b = 2: c = 2: a = 2
GOTO 10999
13999
GOTO beginp:
CLS
GOTO 10999

begin:
IF level% = 1 THEN nuke% = 40
IF level% = 2 THEN nuke% = 45
IF level% = 3 THEN nuke% = 50
IF level% = 4 THEN nuke% = 55
IF level% = 5 THEN nuke% = 60
IF level% = 6 THEN nuke% = 65
IF level% = 7 THEN nuke% = 70
IF level% = 8 THEN nuke% = 75
IF level% = 1 AND diffic = 1 THEN beat% = ((nuke% * 150) / 2)
IF level% = 1 AND diffic = 2 THEN beat% = ((nuke% * 100) / 2)
IF level% = 1 AND diffic = 3 THEN beat% = ((nuke% * 50) / 2)
IF level% = 2 AND diffic = 1 THEN beat% = ((nuke% * 150) / 2)
IF level% = 2 AND diffic = 2 THEN beat% = ((nuke% * 100) / 2)
IF level% = 2 AND diffic = 3 THEN beat% = ((nuke% * 50) / 2)
IF level% = 3 AND diffic = 1 THEN beat% = ((nuke% * 150) / 2)
IF level% = 3 AND diffic = 2 THEN beat% = ((nuke% * 100) / 2)
IF level% = 3 AND diffic = 3 THEN beat% = ((nuke% * 50) / 2)
IF level% = 4 AND diffic = 1 THEN beat% = ((nuke% * 150) / 2)
IF level% = 4 AND diffic = 2 THEN beat% = ((nuke% * 100) / 2)
IF level% = 4 AND diffic = 3 THEN beat% = ((nuke% * 50) / 2)
IF level% = 5 AND diffic = 1 THEN beat% = ((nuke% * 150) / 2)
IF level% = 5 AND diffic = 2 THEN beat% = ((nuke% * 100) / 2)
IF level% = 5 AND diffic = 3 THEN beat% = ((nuke% * 50) / 2)
IF level% = 6 AND diffic = 1 THEN beat% = ((nuke% * 150) / 2)
IF level% = 6 AND diffic = 2 THEN beat% = ((nuke% * 100) / 2)
IF level% = 6 AND diffic = 3 THEN beat% = ((nuke% * 50) / 2)
IF level% = 7 AND diffic = 1 THEN beat% = ((nuke% * 150) / 2)
IF level% = 7 AND diffic = 2 THEN beat% = ((nuke% * 100) / 2)
IF level% = 7 AND diffic = 3 THEN beat% = ((nuke% * 50) / 2)
IF level% = 8 AND diffic = 1 THEN beat% = ((nuke% * 150) / 2)
IF level% = 8 AND diffic = 2 THEN beat% = ((nuke% * 100) / 2)
IF level% = 8 AND diffic = 3 THEN beat% = ((nuke% * 50) / 2)

SCREEN 12
CLS
COLOR 15
LOCATE 2, 33
PRINT "AntaRctic BlaZe"
LOCATE 4, 2
PRINT "Use "; CHR$(17); ""; CHR$(16); " to move target"
LOCATE 5, 2
PRINT "HINT: When the target goes of the screen it"
LOCATE 6, 2
PRINT "shows up at the other end of the screen."
LOCATE 7, 2
PRINT "Use this to your advantage"
LOCATE 9, 33
PRINT "Next Level: "; level%
LOCATE 10, 33
PRINT "Score to Defeat: "; beat%
LOCATE 30, 2
PRINT "<Enter to begin>"

hick:
r$ = INKEY$

SELECT CASE r$
CASE CHR$(13)
GOTO beging:
CASE ELSE
GOTO hick:
END SELECT
GOTO hick:
beging:
SCREEN 12
COLOR 2
RANDOMIZE TIMER
REM idea for AntaRtic BlaZe
score% = 0
IF level% = 1 THEN nuke% = 40
IF level% = 2 THEN nuke% = 45
IF level% = 3 THEN nuke% = 50
IF level% = 4 THEN nuke% = 55
IF level% = 5 THEN nuke% = 60
IF level% = 6 THEN nuke% = 65
IF level% = 7 THEN nuke% = 70
IF level% = 8 THEN nuke% = 75
a = 40
raitio% = 8

x = 1
dd = 15

life% = 5
909 CLS
IF dd = 15 THEN dd = 7: GOTO 12309

IF dd = 8 THEN dd = 15: GOTO 12309

IF dd = 7 THEN dd = 8: GOTO 12309

12309
COLOR dd
CIRCLE (200, 60), 30
PAINT (200, 60)
CIRCLE (150, 55), 25
PAINT (140, 55)
CIRCLE (175, 40), 25
PAINT (175, 40)
CIRCLE (170, 70), 20
PAINT (170, 75)
CIRCLE (215, 40), 20
PAINT (215, 33)
CIRCLE (300, 50), 20
PAINT (300, 50)
CIRCLE (310, 60), 25
PAINT (310, 70)
CIRCLE (315, 40), 20
PAINT (315, 35)
CIRCLE (335, 35), 25
PAINT (340, 30)
CIRCLE (340, 65), 15
PAINT (340, 60)
CIRCLE (360, 50), 25
PAINT (360, 50)
CIRCLE (500, 50), 30
PAINT (500, 50)
CIRCLE (460, 40), 25
PAINT (460, 40)
CIRCLE (440, 35), 15
PAINT (430, 35)
CIRCLE (480, 25), 15
PAINT (480, 20)
CIRCLE (530, 40), 20
PAINT (530, 35)
CIRCLE (550, 55), 25
PAINT (550, 55)
CIRCLE (570, 30), 25
PAINT (570, 30)

COLOR 4
PRINT "                              Anta";
COLOR 15
PRINT "R";
COLOR 4
PRINT "ctic Bla";
COLOR 15
PRINT "Z";
COLOR 4
PRINT "e "
PRINT "Level: "; level%
PRINT "Score%"; score%
PRINT "Flakes left: "; nuke%
PRINT "(Q)uit"

COLOR 2
q = q + 1
y = INT(RND * 65) + 10
1009
IF y >= 5 AND y <= 9 THEN point1% = 1: y = 7.5
IF y >= 10 AND y <= 14 THEN point1% = 2: y = 12.5
IF y >= 15 AND y <= 19 THEN point1% = 3: y = 17.5
IF y >= 20 AND y <= 24 THEN point1% = 4: y = 22.5
IF y >= 25 AND y <= 29 THEN point1% = 5: y = 27.5
IF y >= 30 AND y <= 34 THEN point1% = 6: y = 32.5
IF y >= 35 AND y <= 39 THEN point1% = 7: y = 37.5
IF y >= 40 AND y <= 44 THEN point1% = 8: y = 42.5
IF y >= 45 AND y <= 49 THEN point1% = 9: y = 47.5
IF y >= 50 AND y <= 54 THEN point1% = 10: y = 52.5
IF y >= 55 AND y <= 59 THEN point1% = 11: y = 57.5
IF y >= 60 AND y <= 64 THEN point1% = 12: y = 62.5
IF y >= 65 AND y <= 69 THEN point1% = 13: y = 67.5
IF y >= 70 AND y <= 74 THEN point1% = 14: y = 72.5
IF a >= 5 AND a <= 9 THEN point2% = 1
IF a >= 10 AND a <= 14 THEN point2% = 2
IF a >= 15 AND a <= 19 THEN point2% = 3
IF a >= 20 AND a <= 24 THEN point2% = 4
IF a >= 25 AND a <= 29 THEN point2% = 5
IF a >= 30 AND a <= 34 THEN point2% = 6
IF a >= 35 AND a <= 39 THEN point2% = 7
IF a >= 40 AND a <= 44 THEN point2% = 8
IF a >= 45 AND a <= 49 THEN point2% = 9
IF a >= 50 AND a <= 54 THEN point2% = 10
IF a >= 55 AND a <= 59 THEN point2% = 11
IF a >= 60 AND a <= 64 THEN point2% = 12
IF a >= 65 AND a <= 69 THEN point2% = 13
IF a >= 70 AND a <= 74 THEN point2% = 14


COLOR 1
LOCATE 27, a
PRINT ""; CHR$(219); ""; CHR$(219); ""; CHR$(219); ""; CHR$(219); ""; CHR$(219); ""; CHR$(219)
1109
a$ = INKEY$
PLAYMUSiC
SELECT CASE a$
CASE CHR$(0) + "K"
COLOR 0
LOCATE 27, a
PRINT ""; CHR$(219); ""; CHR$(219); ""; CHR$(219); ""; CHR$(219); ""; CHR$(219); ""; CHR$(219)
a = a - 5
PLAYMUSiC
IF a < 5 THEN a = 75
IF a > 75 THEN a = 5
GOTO 1009
CASE CHR$(0) + "M"
COLOR 0
LOCATE 27, a
PRINT ""; CHR$(219); ""; CHR$(219); ""; CHR$(219); ""; CHR$(219); ""; CHR$(219); ""; CHR$(219)

a = a + 5
IF a < 5 THEN a = 75
IF a > 75 THEN a = 5
GOTO 1009
CASE CHR$(113)
GOTO start:
CASE CHR$(81)
GOTO start:
END SELECT
COLOR 0
LOCATE x, y
PRINT ""; CHR$(15)
COLOR 15
x = x + 1
IF x > 25 THEN GOTO 1209
LOCATE x, y
PRINT ""; CHR$(15)
IF Speed = 1 THEN GOTO spd1:
IF Speed = 2 THEN GOTO spd2:
IF Speed = 3 THEN GOTO spd3:
IF Speed = 4 THEN GOTO spd4:
IF Speed = 5 THEN GOTO spd5:
IF Speed = 6 THEN GOTO spd6:
IF Speed = 7 THEN GOTO spd7:
IF Speed = 8 THEN GOTO spd8:
spd1:
IF level% = 1 THEN PLAY "p20"
IF level% = 2 THEN PLAY "p25"
IF level% = 3 THEN PLAY "p30"
IF level% = 4 THEN PLAY "p35"
IF level% = 5 THEN PLAY "p40"
IF level% = 6 THEN PLAY "p45"
IF level% = 7 THEN PLAY "p50"
IF level% = 8 THEN PLAY "p55"
GOTO 1109

spd2:
IF level% = 1 THEN PLAY "p20"
IF level% = 2 THEN PLAY "p25"
IF level% = 3 THEN PLAY "p30"
IF level% = 4 THEN PLAY "p35"
IF level% = 5 THEN PLAY "p40"
IF level% = 6 THEN PLAY "p45"
IF level% = 7 THEN PLAY "p50"
IF level% = 8 THEN PLAY "p55"
GOTO 1109
spd3:
IF level% = 1 THEN PLAY "p19"
IF level% = 2 THEN PLAY "p24"
IF level% = 3 THEN PLAY "p29"
IF level% = 4 THEN PLAY "p33"
IF level% = 5 THEN PLAY "p39"
IF level% = 6 THEN PLAY "p44"
IF level% = 7 THEN PLAY "p49"
IF level% = 8 THEN PLAY "p54"
GOTO 1109
spd4:
IF level% = 1 THEN PLAY "p18"
IF level% = 2 THEN PLAY "p23"
IF level% = 3 THEN PLAY "p28"
IF level% = 4 THEN PLAY "p32"
IF level% = 5 THEN PLAY "p38"
IF level% = 6 THEN PLAY "p43"
IF level% = 7 THEN PLAY "p48"
IF level% = 8 THEN PLAY "p53"
GOTO 1109
spd5:
IF level% = 1 THEN PLAY "p17"
IF level% = 2 THEN PLAY "p22"
IF level% = 3 THEN PLAY "p27"
IF level% = 4 THEN PLAY "p31"
IF level% = 5 THEN PLAY "p37"
IF level% = 6 THEN PLAY "p42"
IF level% = 7 THEN PLAY "p47"
IF level% = 8 THEN PLAY "p52"
GOTO 1109
spd6:
IF level% = 1 THEN PLAY "p16"
IF level% = 2 THEN PLAY "p21"
IF level% = 3 THEN PLAY "p26"
IF level% = 4 THEN PLAY "p30"
IF level% = 5 THEN PLAY "p36"
IF level% = 6 THEN PLAY "p41"
IF level% = 7 THEN PLAY "p46"
IF level% = 8 THEN PLAY "p51"
GOTO 1109
spd7:
IF level% = 1 THEN PLAY "p15"
IF level% = 2 THEN PLAY "p20"
IF level% = 3 THEN PLAY "p25"
IF level% = 4 THEN PLAY "p29"
IF level% = 5 THEN PLAY "p35"
IF level% = 6 THEN PLAY "p40"
IF level% = 7 THEN PLAY "p45"
IF level% = 8 THEN PLAY "p50"
GOTO 1109
spd8:
IF level% = 1 THEN PLAY "p14"
IF level% = 2 THEN PLAY "p19"
IF level% = 3 THEN PLAY "p24"
IF level% = 4 THEN PLAY "p28"
IF level% = 5 THEN PLAY "p34"
IF level% = 6 THEN PLAY "p39"
IF level% = 7 THEN PLAY "p44"
IF level% = 8 THEN PLAY "p49"
GOTO 1109

1209
IF point1% = point2% THEN GOTO weed:
IF point1% <> point2% THEN GOTO bud:
weed:
IF diffic = 1 THEN score% = score% + 150: PLAY "l32 o4 d": GOTO bong:
IF diffic = 2 THEN score% = score% + 100: PLAY "l32 o4 d": GOTO bong:
IF diffic = 3 THEN score% = score% + 50: PLAY "l32 o4 d": GOTO bong:
bud:
IF diffic = 1 THEN score% = score% - 50: PLAY "l32 o2 e": GOTO bong:
IF diffic = 2 THEN score% = score% - 100: PLAY "l32 o2 e": GOTO bong:
IF diffic = 3 THEN score% = score% - 150: PLAY "l32 o2 e": GOTO bong:
bong:
nuke% = nuke% - 1
PLAYMUSiC
IF nuke% < 1 THEN GOTO poop:
x = 1
GOTO 909
poop:
PLAYMUSiC
IF level% = 1 THEN nuke% = 40
IF level% = 2 THEN nuke% = 45
IF level% = 3 THEN nuke% = 50
IF level% = 4 THEN nuke% = 55
IF level% = 5 THEN nuke% = 60
IF level% = 6 THEN nuke% = 65
IF level% = 7 THEN nuke% = 70
IF level% = 8 THEN nuke% = 75
IF diffic = 1 THEN GOTO spid:
IF diffic = 2 THEN GOTO spid1:
IF diffic = 3 THEN GOTO spid2:
spid:
way% = nuke% * 150
dream% = way / 2
IF score% >= dream% THEN level% = level% + 1
IF score% < dream% THEN lose: GOTO start:
PLAYMUSiC
IF level% > 8 THEN win: GOTO start:
'IF level% < 8 THEN lose: GOTO start:
GOTO begin
spid1:
way% = nuke% * 100
dream% = way / 2
IF score% > dream% THEN level% = level% + 1
IF level% > 8 THEN win: GOTO start:
IF score% < dream% THEN lose: GOTO start:
PLAYMUSiC
GOTO begin
spid2:
way% = nuke% * 50
PLAYMUSiC
dream% = way / 2
IF score% > dream% THEN level% = level% + 1
IF level% > 8 THEN win: GOTO start:
IF score% < dream% THEN lose: GOTO start:
GOTO begin

beginp:
SCREEN 12
COLOR 2
RANDOMIZE TIMER
REM idea for AntaRtic BlaZe
nuke% = 10
a = 40
raitio% = 8
x = 1
dd = 7
win1% = 0
life% = 5
9 CLS
IF dd = 15 THEN dd = 7: GOTO 123

IF dd = 8 THEN dd = 15: GOTO 123

IF dd = 7 THEN dd = 8: GOTO 123

123
COLOR dd
CIRCLE (200, 60), 30
PAINT (200, 60)
CIRCLE (150, 55), 25
PAINT (140, 55)
CIRCLE (175, 40), 25
PAINT (175, 40)
CIRCLE (170, 70), 20
PAINT (170, 75)
CIRCLE (215, 40), 20
PAINT (215, 33)
CIRCLE (300, 50), 20
PAINT (300, 50)
CIRCLE (310, 60), 25
PAINT (310, 70)
CIRCLE (315, 40), 20
PAINT (315, 35)
CIRCLE (335, 35), 25
PAINT (340, 30)
CIRCLE (340, 65), 15
PAINT (340, 60)
CIRCLE (360, 50), 25
PAINT (360, 50)
CIRCLE (500, 50), 30
PAINT (500, 50)
CIRCLE (460, 40), 25
PAINT (460, 40)
CIRCLE (440, 35), 15
PAINT (430, 35)
CIRCLE (480, 25), 15
PAINT (480, 20)
CIRCLE (530, 40), 20
PAINT (530, 35)
CIRCLE (550, 55), 25
PAINT (550, 55)
CIRCLE (570, 30), 25
PAINT (570, 30)

COLOR 4
PRINT "                              Anta";
COLOR 15
PRINT "R";
COLOR 4
PRINT "tic Bla";
COLOR 15
PRINT "Z";
COLOR 4
PRINT "e "
PRINT "Score%"; score%
PRINT "(Q)uit"
PRINT ""; CHR$(24); " Speed Up!"
PRINT ""; CHR$(25); " Slow Down!"
PRINT "Speed: "; raitio%
COLOR 2
q = q + 1
y = INT(RND * 65) + 10
10
IF y >= 5 AND y <= 9 THEN point1% = 1: y = 7.5
IF y >= 10 AND y <= 14 THEN point1% = 2: y = 12.5
IF y >= 15 AND y <= 19 THEN point1% = 3: y = 17.5
IF y >= 20 AND y <= 24 THEN point1% = 4: y = 22.5
IF y >= 25 AND y <= 29 THEN point1% = 5: y = 27.5
IF y >= 30 AND y <= 34 THEN point1% = 6: y = 32.5
IF y >= 35 AND y <= 39 THEN point1% = 7: y = 37.5
IF y >= 40 AND y <= 44 THEN point1% = 8: y = 42.5
IF y >= 45 AND y <= 49 THEN point1% = 9: y = 47.5
IF y >= 50 AND y <= 54 THEN point1% = 10: y = 52.5
IF y >= 55 AND y <= 59 THEN point1% = 11: y = 57.5
IF y >= 60 AND y <= 64 THEN point1% = 12: y = 62.5
IF y >= 65 AND y <= 69 THEN point1% = 13: y = 67.5
IF y >= 70 AND y <= 74 THEN point1% = 14: y = 72.5
IF a >= 5 AND a <= 9 THEN point2% = 1
IF a >= 10 AND a <= 14 THEN point2% = 2
IF a >= 15 AND a <= 19 THEN point2% = 3
IF a >= 20 AND a <= 24 THEN point2% = 4
IF a >= 25 AND a <= 29 THEN point2% = 5
IF a >= 30 AND a <= 34 THEN point2% = 6
IF a >= 35 AND a <= 39 THEN point2% = 7
IF a >= 40 AND a <= 44 THEN point2% = 8
IF a >= 45 AND a <= 49 THEN point2% = 9
IF a >= 50 AND a <= 54 THEN point2% = 10
IF a >= 55 AND a <= 59 THEN point2% = 11
IF a >= 60 AND a <= 64 THEN point2% = 12
IF a >= 65 AND a <= 69 THEN point2% = 13
IF a >= 70 AND a <= 74 THEN point2% = 14


COLOR 1
LOCATE 27, a
PRINT ""; CHR$(219); ""; CHR$(219); ""; CHR$(219); ""; CHR$(219); ""; CHR$(219); ""; CHR$(219)
11
PLAYMUSiC
a$ = INKEY$
SELECT CASE a$
CASE CHR$(0) + "K"
COLOR 0
LOCATE 27, a
PRINT ""; CHR$(219); ""; CHR$(219); ""; CHR$(219); ""; CHR$(219); ""; CHR$(219); ""; CHR$(219)
a = a - 5
IF a < 5 THEN a = 75
IF a > 75 THEN a = 5
GOTO 10
CASE CHR$(0) + "M"
COLOR 0
LOCATE 27, a
PRINT ""; CHR$(219); ""; CHR$(219); ""; CHR$(219); ""; CHR$(219); ""; CHR$(219); ""; CHR$(219)

a = a + 5
IF a < 5 THEN a = 75
IF a > 75 THEN a = 5
GOTO 10
CASE CHR$(113)

GOTO start:
CASE CHR$(81)

GOTO start:
CASE CHR$(0) + "H"
raitio% = raitio% - 1
IF raitio% < 1 THEN raitio% = 1

GOTO 9
CASE CHR$(0) + "P"

raitio% = raitio% + 1
IF raitio% > 8 THEN raitio% = 8
GOTO 9
END SELECT
COLOR 0
LOCATE x, y
PRINT ""; CHR$(15)
COLOR 15
x = x + 1
IF x > 25 THEN GOTO 12
LOCATE x, y
PRINT ""; CHR$(15)
IF raitio% = 8 THEN PLAY "p20"
IF raitio% = 7 THEN PLAY "p25"
IF raitio% = 6 THEN PLAY "p30"
IF raitio% = 5 THEN PLAY "p35"
IF raitio% = 4 THEN PLAY "p40"
IF raitio% = 3 THEN PLAY "p42"
IF raitio% = 2 THEN PLAY "p44"
IF raitio% = 1 THEN PLAY "p46"
GOTO 11
12
IF point1% = point2% THEN score% = score% + 100: PLAY "l32 o4 d"
IF point1% <> point2% THEN score% = score% - 200: PLAY "l32 o2 e"

x = 1
GOTO 9

REM $STATIC
SUB about
CLS
'INTRO
SCREEN 0
SCREEN 12
COLOR 15
LOCATE 2, 30
PRINT "AntaRctic BlaZe  V 1.1"
COLOR 14
LOCATE 6, 35
PRINT "Credits:"
COLOR 4
LOCATE 8, 20
COLOR 1
PRINT "Concept:"
LOCATE 8, 50
COLOR 14
PRINT "Jesse Haag"
LOCATE 9, 20
COLOR 1
PRINT "Programmed by:"
LOCATE 9, 50
COLOR 14
PRINT "Jesse Haag"
LOCATE 10, 20
COLOR 1
PRINT "Muzak and additional Code:"
COLOR 14
LOCATE 10, 50
PRINT "E.T. Dorn"
COLOR 1
LOCATE 11, 20
PRINT "Distribution:"
COLOR 4
LOCATE 11, 50
PRINT "Turbo Systems Software"
COLOR 2
LOCATE 13, 15
PRINT "TSS Staff as of 1996: E.T. Dorn, Brian Miles, Jesse Haag"
COLOR 1
LOCATE 16, 19
PRINT "    Programmed on a Omni Tech 150mhz Pentium"
LOCATE 17, 13
PRINT "Visit us: http://members.aol.com/roadbustr/homepage/tss.htm"
LOCATE 18, 13
PRINT "Actually, try TRHOnline.com instead, as that old page is gone."
LOCATE 19, 3
PRINT "AntaRtic BlaZe and any similarities are (TM) and (c) Turbo Systems Software"
COLOR 3
PRINT "              Music Was written using M/K Production's MKJamz MIDI Format"
'PRINT ""
COLOR 1
LOCATE 20, 34
COLOR 2
PRINT "[Press Enter]"
case1:
w$ = INKEY$
SELECT CASE w$
CASE CHR$(13)
GOTO zap:
CASE ELSE
GOTO case1:
END SELECT
GOTO case1:
zap:
END SUB

SUB CloseChannels
IF MaxChannel% > 4 THEN FirstLoop% = 3 ELSE FirstLoop% = MaxChannel%
 FOR Channel% = 0 TO FirstLoop%
  WriteReg &HB0 + Channel%, 0
 NEXT
 IF FirstLoop% = MaxChannel% THEN EXIT SUB
 FOR Channel% = Channel% TO MaxChannel%
  WriteReg &HB0 + Channel% + 5, 0
 NEXT
END SUB

SUB ENDer
SBinit
CLOSE
SCREEN 0
COLOR 7, 0
CLS
COLOR 15, 4
PRINT "                                AntaRctic BlaZe v1.1                            "
COLOR 15, 1
PRINT "             By Jesse Haag                            Produced by"; : COLOR 4: PRINT ; " TSS           "
PRINT "                                                                                "
COLOR 15
PRINT "        Usually I put some witty joke here mentioning that this is a            "
PRINT "        Shareware copy of AntaRctic BlaZe v1.1 (Formerly called AntaRtic        "
PRINT "        BlaZe due to our bad spelling) you should pay us the 5$ and get it      "
PRINT "        Over with. But,  I'm not going to bother with a joke (I'm               "
PRINT "        not that funny anyways!) but I'll merely say it.  Give us Money,        "
PRINT "        And we'll give you more features for the program, like selectable       "
PRINT "        Vehicles and such.  Now it's only 5$. If you insist on giving us a      "
PRINT "        check instead of cash, make sure you write the check out to             "
PRINT "        'Cash' or 'Eric Dorn'.  Mail the money, a note saying what program      "
PRINT "        it's for, and a self addressed stamped envelope to:                     "
COLOR 14
PRINT "                                                                                "
PRINT "                              Turbo Systems Software                            "
PRINT "                              c/o Eric Dorn                                     "
PRINT "                              2526 N 73rd ST                                    "
PRINT "                              Wauwatosa, WI  53213-1214                         "
PRINT "                                                                                "
COLOR 4
PRINT "             Turbo Systems Software:                                            "
COLOR 15
PRINT "             Website: http://members.aol.com/roadbustr/homepage/tss.htm         "
PRINT "              E-Mail: TSSoft1@aol.com                                           "
COLOR 7, 0
END
END SUB

SUB first (Speed)
SCREEN 12
75
CLS
IF q = 1 THEN LOCATE 14, 4: PRINT "Yeah right you liar!!!"
76
COLOR 15
LOCATE 2, 33
PRINT "Ana";
COLOR 1
PRINT "R";
COLOR 15
PRINT "ctic Bla";
COLOR 1
PRINT "Z";
COLOR 15
PRINT "e ";
LOCATE 3, 1
PRINT "Enter your Computer Speed"
COLOR 2
LOCATE 4, 1
PRINT "1)Super Suck"
LOCATE 5, 1
PRINT "2)33mhz"
LOCATE 6, 1
PRINT "3)66mhz"
LOCATE 7, 1
PRINT "4)75mhz"
LOCATE 8, 1
PRINT "5)100mhz"
LOCATE 9, 1
PRINT "6)133mhz"
LOCATE 10, 1
PRINT "7)166mhz"
LOCATE 11, 1
PRINT "8)200mhz"
LOCATE 12, 1
PRINT "9)Any CRAY"
LOCATE 13, 1
PRINT "0)Quit"

LOCATE 18, 10: PRINT "Isn't this a dated selection? Just pick one."
e$ = INKEY$
SELECT CASE e$
CASE CHR$(49)
Speed = 1
GOTO 77
CASE CHR$(50)
Speed = 2
GOTO 77
CASE CHR$(51)
Speed = 3
GOTO 77
CASE CHR$(52)
Speed = 4
GOTO 77
CASE CHR$(53)
Speed = 5
GOTO 77
CASE CHR$(54)
Speed = 6
GOTO 77
CASE CHR$(55)
Speed = 7
GOTO 77
CASE CHR$(56)
Speed = 8
GOTO 77
CASE CHR$(57)
q = 1
GOTO 75
CASE CHR$(48)
ENDer
'RUN "c:\turbo\games.bas"
CASE ELSE
GOTO 76
END SELECT
GOTO 76
77

END SUB

SUB INTRO
COLOR 15
CLS
message
PRINT "M";
message
PRINT "E";
message
PRINT "S";
message
PRINT "S";
message
PRINT "A";
message
PRINT "G";
message
PRINT "E";
message
PRINT " ";
message
PRINT "F";
message
PRINT "R";
message
PRINT "O";
message
PRINT "M";
message
PRINT " ";
message
PRINT "H";
message
PRINT "E";
message
PRINT "A";
message
PRINT "D";
message
PRINT "Q";
message
PRINT "U";
message
PRINT "A";
message
PRINT "R";
message
PRINT "T";
message
PRINT "E";
message
PRINT "R";
message
PRINT "S:"

message
PRINT "S";
message
PRINT "O";
message
PRINT "V";
message
PRINT "I";
message
PRINT "E";
message
PRINT "T";
message
PRINT " ";
message
PRINT "S";
message
PRINT "P";
message
PRINT "I";
message
PRINT "E";
message
PRINT "S";
message
PRINT " ";
message
PRINT "W";
message
PRINT "E";
message
PRINT "R";
message
PRINT "E";
message
PRINT " ";

message
PRINT "C";
message
PRINT "A";
message
PRINT "U";
message
PRINT "G";
message
PRINT "H";
message
PRINT "T";
message
PRINT " ";
message
PRINT "R";
message
PRINT "E";
message
PRINT "L";
message
PRINT "E";
message
PRINT "A";
message
PRINT "S";
message
PRINT "I";
message
PRINT "N";
message
PRINT "G";
message
PRINT " ";
message
PRINT "R";
message
PRINT "A";
message
PRINT "D";
message
PRINT "I";
message
PRINT "O";
message
PRINT "A";
message
PRINT "C";
message
PRINT "T";
message
PRINT "I";
message
PRINT "V";
message
PRINT "E";
message
PRINT " ";
message
PRINT "W";
message
PRINT "A";
message
PRINT "S";
message
PRINT "T";
message
PRINT "E";
message
PRINT " "


message
PRINT "I";
message
PRINT "N";
message
PRINT " ";
message
PRINT "A";
message
PRINT "N";
message
PRINT "T";
message
PRINT "A";
message
PRINT "R";
message
PRINT "C";
message
PRINT "T";
message
PRINT "I";
message
PRINT "C";
message
PRINT " ";
message
PRINT "S";
message
PRINT "N";
message
PRINT "O";
message
PRINT "W";
message
PRINT " ";
message
PRINT "C";
message
PRINT "L";
message
PRINT "O";
message
PRINT "U";
message
PRINT "D";
message
PRINT "S";
message
PRINT "."
message
PRINT "Y";
message
PRINT "O";
message
PRINT "U";
message
PRINT "R";
message
PRINT " ";
message
PRINT "M";
message
PRINT "I";
message
PRINT "S";
message
PRINT "S";
message
PRINT "I";
message
PRINT "O";
message
PRINT "N";
message
PRINT ":";
message
PRINT " "
message
PRINT "S";
message
PRINT "T";
message
PRINT "O";
message
PRINT "P";
message
PRINT " ";
message
PRINT "T";
message
PRINT "H";
message
PRINT "E";
message
PRINT " ";
message
PRINT "R";
message
PRINT "A";
message
PRINT "D";
message
PRINT "I";
message
PRINT "O";
message
PRINT "A";
message
PRINT "C";
message
PRINT "T";
message
PRINT "I";
message
PRINT "V";
message
PRINT "E";
message
PRINT " ";
message
PRINT "S";
message
PRINT "N";
message
PRINT "O";
message
PRINT "W";
message
PRINT " ";
message
PRINT "F";
message
PRINT "R";
message
PRINT "O";
message
PRINT "M";
message
PRINT " ";
message
PRINT "T";
message
PRINT "O";
message
PRINT "U";
message
PRINT "C";
message
PRINT "H";
message
PRINT "I";
message
PRINT "N";
message
PRINT "G";
message
PRINT " ";
message
PRINT "D";
message
PRINT "O";
message
PRINT "W";
message
PRINT "N";
message
PRINT "."
message
PRINT "G";
message
PRINT "O";
message
PRINT "O";
message
PRINT "D";
message
PRINT " ";
message
PRINT "L";
message
PRINT "U";
message
PRINT "C";
message
PRINT "K";
message
PRINT "."
PLAY "o0 l16 l10gl16geegeegeegeeggg<g"
PLAY "o2 l16 bbggeep10eeggbbp30"
PLAY "o0 l16 l10gl16geegeegeegeeggg<g"

END SUB

FUNCTION LoadJamFile% (File$)

OPEN File$ FOR BINARY AS #1

 IF LOF(1) < 2 THEN
   CLOSE #1
   KILL File$
   LoadJamFile% = -1
   EXIT FUNCTION
 END IF

 IF INPUT$(6, #1) <> "MKJamz" THEN
   LoadJamFile% = -2
   EXIT FUNCTION
 END IF

 GET #1, , Version!
 IF Version! > 1.1 THEN
  LoadJamFile% = -3
  EXIT FUNCTION
 END IF

 GET #1, , MaxChannel%

  FOR x% = 1 TO MaxChannel%
    GET #1, , CurrentIns
    Save% = x%
    SetIns x%
    x% = Save%
   NEXT

 GET #1, , MaxNotes%

  REDIM SongBuf(1 TO (MaxChannel% + 1) * MaxNotes%) AS INTEGER
  REDIM ChannelStat(1 TO MaxChannel%) AS ChannelType

  FOR x% = 1 TO MaxChannel%
    GET #1, , ChannelStat(x%).Defined
    ChannelStat(x%).SongPtr = 1
    ChannelStat(x%).Octave = 4
  NEXT


  ' Begin of FAST music loader...load 40,000 bytes of data in no time flat!
  ' Almost like BLOAD/BSAVE but much more flexible.  (If you know what you
  ' are doing.)


  RemBytes& = LOF(1) - SEEK(1)  ' The size, in bytes (not ints) of song data

  BufferSize% = 2000           ' The buffer size to use.

  DEF SEG = VARSEG(SongBuf(1)) ' The segment of the song buffer
  Ptr& = VARPTR(SongBuf(1))    ' Pointer to the song buffer

  LeftBytes& = RemBytes& MOD BufferSize% ' The amount of left over bytes

  IF (LeftBytes& < RemBytes&) THEN
    FOR QuickLoad% = 1 TO (RemBytes& - LeftBytes&) / BufferSize%
       Buffer$ = INPUT$(BufferSize%, #1) ' Load all the data into buffer
         FOR x% = 1 TO LEN(Buffer$)
            POKE Ptr&, ASC(MID$(Buffer$, x%, 1))
            Ptr& = Ptr& + 1
         NEXT
       RemBytes& = RemBytes& - BufferSize%
    NEXT
  END IF

  IF (LeftBytes& > 0) THEN
    Buffer$ = INPUT$(LeftBytes&, #1)
     FOR x% = 1 TO LEN(Buffer$)
        POKE Ptr&, ASC(MID$(Buffer$, x%, 1))
        Ptr& = Ptr& + 1
     NEXT
   END IF

  DEF SEG

CLOSE #1

LoadJamFile% = 1

END FUNCTION

SUB logo
    CLS
    SCREEN 13
    a = 30: b = 35: c = 16
DO
a = a + 1: b = b + 1: c = c + x
IF a > 250 THEN a = 16
IF b > 250 THEN b = 18
IF c > 30 THEN x = -1
IF c < 17 THEN x = 1
    VIEW (40, 20)-(100, 130), a, a
    COLOR c
    LOCATE 8, 14: PRINT "Turbo Systems Software"
    LOCATE 9, 19: PRINT "Presents..."
    VIEW (110, 120)-(230, 180), b, b
LOOP UNTIL INKEY$ = " "

END SUB

SUB lose
CLS
DIM byte AS STRING * 1
CLS
'INPUT "Bitmap Filename"; data$

data$ = "blaze.bmp"

IF LTRIM$(RTRIM$(data$)) = "" THEN END
OPEN data$ FOR BINARY AS #1
IF LOF(1) = 0 THEN PRINT "File not found!": CLOSE : KILL data$: END

table$ = INPUT$(54, #1)  'Get the file header (54 bytes)
REDIM table&(30)           'Create numerical array for header
DEF SEG = VARSEG(table&(1))
pointer% = VARPTR(table&(1))

'Poke the data from string "table$" into numerical array "table&"
FOR x% = 0 TO 51
 POKE pointer% + x%, ASC(MID$(table$, x% + 3, 1))
NEXT
DEF SEG

'Check for valid file type
IF MID$(table$, 1, 2) <> "BM" OR table&(4) <> 40 THEN
   PRINT "Not a valid *.BMP file!": END
END IF
IF table&(8) <> 0 THEN
   PRINT "This program will not diplay RLE encoded files": END
END IF
'IF ASC(MID$(table$, 29, 1)) <> 4 THEN
'   PRINT "Only 16 color bitmaps are supported!": END
'END IF

'Set the video mode for best picture fit
IF (table&(5) < 321) AND (table&(6) < 201) THEN
   SCREEN 12
ELSE
   SCREEN 12
END IF
LOCATE 2, 1


thecolors$ = INPUT$(table&(3) - 54, #1) 'Read in pallette info

DEF SEG = VARSEG(pal&)
pointer% = VARPTR(pal&)
'Poke the pallette info from the string "thecolors$"
'into pal& and reduce to 6 bits per byte.
FOR x% = 0 TO 63 STEP 4
 POKE pointer%, (ASC(MID$(thecolors$, x% + 3, 1))) \ 4
 POKE pointer% + 1, (ASC(MID$(thecolors$, x% + 2, 1))) \ 4
 POKE pointer% + 2, (ASC(MID$(thecolors$, x% + 1, 1))) \ 4
 POKE pointer% + 3, 0
PALETTE x% \ 4, pal&
NEXT
DEF SEG



'Read in Bitmap data and set pixels accordingly
y% = table&(6) 'Put number of vertical pixels into y%
DO
  data$ = INPUT$((((table&(5) - 1) OR 7) + 1) \ 2, #1)
    IF (table&(5) \ 2) < LEN(data$) THEN
       linelength% = table&(5) \ 2
    ELSE
       linelength% = LEN(data$)
    END IF
    FOR x% = 1 TO linelength%
      pixel% = ASC(MID$(data$, x%, 1))
      PSET (x% * 2 + 1, y%), pixel% AND 15
      PSET (x% * 2, y%), pixel% \ 16
     NEXT
    y% = y% - 1
LOOP UNTIL EOF(1) 'OR INKEY$ <> ""
CLOSE
LOCATE 15, 30
PRINT "YOU LOSE!!!!!!!!!"
DO
LOCATE 15, 30
PRINT "YOU LOSE!!!!!!!!!"
a = a + 1
COLOR a
IF a > 14 THEN a = 0
LOOP UNTIL INKEY$ <> ""

END SUB

SUB message
RANDOMIZE TIMER
aaa = INT(RND * 4) + 1
SOUND 500, aaa
PLAY "p40"
END SUB

SUB PLAYMUSiC

FOR Channel% = 1 TO MaxChannel%

  IF ChannelStat(Channel%).Defined = 0 THEN GOTO NoGotosPlease

  RChan% = Channel% - 1

  IF ChannelStat(Channel%).IsDone = 1 THEN
   ChannelStat(Channel%).PStat = TIMER + ChannelStat(Channel%).Speed
   ChannelStat(Channel%).SongPtr = ChannelStat(Channel%).SongPtr + MaxChannel%
   ChannelStat(Channel%).IsDone = 0
   ChannelStat(Channel%).IsPlaying = 0
  END IF

   IF ChannelStat(Channel%).IsPlaying = 0 AND SongBuf(ChannelStat(Channel%).SongPtr + Channel% - 1) <> 0 THEN
    ChannelStat(Channel%).PStat = TIMER + ChannelStat(Channel%).Speed
     SELECT CASE SongBuf(ChannelStat(Channel%).SongPtr + RChan%)
       CASE 68   ' "D"
         WriteReg &HA0 + RChan%, &H81
         WriteReg &HB0 + RChan%, &H21 + 4 * ChannelStat(Channel%).Octave
       CASE 69   ' "E"
         WriteReg &HA0 + RChan%, &HB0
         WriteReg &HB0 + RChan%, &H21 + 4 * ChannelStat(Channel%).Octave
       CASE 70   ' "F"
         WriteReg &HA0 + RChan%, &HCA
         WriteReg &HB0 + RChan%, &H21 + 4 * ChannelStat(Channel%).Octave
       CASE 71    ' "G"
         WriteReg &HA0 + RChan%, &H2
         WriteReg &HB0 + RChan%, &H22 + 4 * ChannelStat(Channel%).Octave
       CASE 65 ' "A"
         WriteReg &HA0 + RChan%, &H41
         WriteReg &HB0 + RChan%, &H22 + 4 * ChannelStat(Channel%).Octave
       CASE 66   ' "B"
         WriteReg &HA0 + RChan%, &H87
         WriteReg &HB0 + RChan%, &H22 + 4 * ChannelStat(Channel%).Octave
       CASE 67  '  "C"
         WriteReg &HA0 + RChan%, &HAE
         WriteReg &HB0 + RChan%, &H22 + 4 * ChannelStat(Channel%).Octave
       CASE 17 ' "C#"
         WriteReg &HA0 + RChan%, &H6B
         WriteReg &HB0 + RChan%, &H21 + 4 * ChannelStat(Channel%).Octave
       CASE 18 ' "D#"
         WriteReg &HA0 + RChan%, &H98
         WriteReg &HB0 + RChan%, &H21 + 4 * ChannelStat(Channel%).Octave
       CASE 20 ' F#"
         WriteReg &HA0 + RChan%, &HE5
         WriteReg &HB0 + RChan%, &H21 + 4 * ChannelStat(Channel%).Octave
       CASE 21 ' "G#"
         WriteReg &HA0 + RChan%, &H20
         WriteReg &HB0 + RChan%, &H22 + 4 * ChannelStat(Channel%).Octave
       CASE 15 ' "A#"
         WriteReg &HA0 + RChan%, &H63
         WriteReg &HB0 + RChan%, &H22 + 4 * ChannelStat(Channel%).Octave
       
       CASE 255
         ChannelStat(Channel%).IsPlaying = 1
         ChannelStat(Channel%).PStat = TIMER + SongBuf(ChannelStat(Channel%).SongPtr + Channel% - 1 + MaxChannel%) / 100
         ChannelStat(Channel%).Flag = -1
       CASE 254
         ChannelStat(Channel%).Octave = SongBuf(ChannelStat(Channel%).SongPtr + Channel% - 1 + MaxChannel%)
         ChannelStat(Channel%).SongPtr = ChannelStat(Channel%).SongPtr + MaxChannel%
       CASE 253
         ChannelStat(Channel%).Speed = SongBuf(ChannelStat(Channel%).SongPtr + Channel% - 1 + MaxChannel%) / 100
         ChannelStat(Channel%).SongPtr = ChannelStat(Channel%).SongPtr + MaxChannel%
       CASE 252
         ChannelStat(Channel%).WaveForm = SongBuf(ChannelStat(Channel%).SongPtr + Channel% - 1 + MaxChannel%) - 300
         ChannelStat(Channel%).SongPtr = ChannelStat(Channel%).SongPtr + MaxChannel%
         IF RChan% > 2 THEN RRChan% = RChan% + 6 ELSE RRChan% = 0
         WriteReg &HE0 + RChan% + RRChan%, ChannelStat(Channel%).WaveForm
       CASE 251
         ChannelStat(1).Flag2 = -1
          FOR MaxChan% = 1 TO MaxChannel%
           ChannelStat(MaxChan%).SongPtr = 1
           ChannelStat(MaxChan%).IsPlaying = 0
           ChannelStat(MaxChan%).IsDone = 0
          NEXT
         CloseChannels
         EXIT SUB
     END SELECT
   END IF

    IF ChannelStat(Channel%).IsPlaying = 1 THEN
     IF TIMER >= ChannelStat(Channel%).PStat THEN
      WriteReg &HB0 + RChan%, 0
      ChannelStat(Channel%).IsDone = 1
       IF ChannelStat(Channel%).Flag = -1 THEN
        ChannelStat(Channel%).SongPtr = ChannelStat(Channel%).SongPtr + MaxChannel%
        ChannelStat(Channel%).Flag = 0
       END IF
     END IF
    END IF
  
   IF ChannelStat(Channel%).SongPtr > MaxChannel% + 1 THEN
     IF SongBuf(ChannelStat(Channel%).SongPtr + RChan%) <> 0 AND SongBuf(ChannelStat(Channel%).SongPtr - MaxChannel% + RChan%) < 250 THEN
       IF ChannelStat(Channel%).IsPlaying = 0 THEN ChannelStat(Channel%).IsPlaying = 1
     END IF
   END IF

NoGotosPlease:
NEXT Channel%


FOR Channel% = 1 TO MaxChannel%

 IF ChannelStat(Channel%).IsPlaying = 0 THEN
  ChannelStat(Channel%).SongPtr = ChannelStat(Channel%).SongPtr + MaxChannel%
  IF ChannelStat(Channel%).SongPtr >= UBOUND(SongBuf) / MaxChannel% THEN
   ChannelStat(Channel%).SongPtr = 1
  END IF
 END IF
NEXT Channel%


END SUB

SUB SBinit
   FOR z% = 1 TO &HF5
     CALL WriteReg(z%, 0)
   NEXT z%
END SUB

SUB SetIns (Channel%)

Channel% = Channel% - 1
CarChan% = Channel%
ModChan% = Channel%

IF Channel% >= 3 THEN
 CarChan% = CarChan% + 5
 ModChan% = ModChan% + 5
END IF

WriteReg &H20 + CarChan%, CurrentIns.CMult  'Plays carrier note at specified octave ch. 1
WriteReg &H23 + ModChan%, CurrentIns.MMult  'Plays modulator note at specified octave ch. 1
WriteReg &H40 + CarChan%, CurrentIns.CLevel   'Set carrier total level to softest ch. 1
WriteReg &H43 + ModChan%, CurrentIns.MLevel   'Set modulator level to loudest ch. 1
WriteReg &H60 + CarChan%, CurrentIns.CAttack  'Set carrier attack and decay ch. 1
WriteReg &H63 + ModChan%, CurrentIns.MAttack  'Set modulator attack and decay ch. 1
WriteReg &H80 + CarChan%, CurrentIns.CSustain 'Set carrier sustain and release ch. 1
WriteReg &H83 + ModChan%, CurrentIns.MSustain 'Set modulator sustain and release ch. 1
END SUB

SUB TimePause
END SUB

SUB win
CLOSE
CLS
'PRINT "You win"
CLS
DIM byte AS STRING * 1
CLS
'INPUT "Bitmap Filename"; data$

data$ = "win.bmp"

IF LTRIM$(RTRIM$(data$)) = "" THEN END
OPEN data$ FOR BINARY AS #1
IF LOF(1) = 0 THEN PRINT "File not found!": CLOSE : KILL data$: END

table$ = INPUT$(54, #1)  'Get the file header (54 bytes)
REDIM table&(30)           'Create numerical array for header
DEF SEG = VARSEG(table&(1))
pointer% = VARPTR(table&(1))

'Poke the data from string "table$" into numerical array "table&"
FOR x% = 0 TO 51
 POKE pointer% + x%, ASC(MID$(table$, x% + 3, 1))
NEXT
DEF SEG

'Check for valid file type
IF MID$(table$, 1, 2) <> "BM" OR table&(4) <> 40 THEN
   PRINT "Not a valid *.BMP file!": END
END IF
IF table&(8) <> 0 THEN
   PRINT "This program will not diplay RLE encoded files": END
END IF
'IF ASC(MID$(table$, 29, 1)) <> 4 THEN
'   PRINT "Only 16 color bitmaps are supported!": END
'END IF

'Set the video mode for best picture fit
IF (table&(5) < 321) AND (table&(6) < 201) THEN
   SCREEN 12
ELSE
   SCREEN 12
END IF
LOCATE 2, 1


thecolors$ = INPUT$(table&(3) - 54, #1) 'Read in pallette info

DEF SEG = VARSEG(pal&)
pointer% = VARPTR(pal&)
'Poke the pallette info from the string "thecolors$"
'into pal& and reduce to 6 bits per byte.
FOR x% = 0 TO 63 STEP 4
 POKE pointer%, (ASC(MID$(thecolors$, x% + 3, 1))) \ 4
 POKE pointer% + 1, (ASC(MID$(thecolors$, x% + 2, 1))) \ 4
 POKE pointer% + 2, (ASC(MID$(thecolors$, x% + 1, 1))) \ 4
 POKE pointer% + 3, 0
PALETTE x% \ 4, pal&
NEXT
DEF SEG



'Read in Bitmap data and set pixels accordingly
y% = table&(6) 'Put number of vertical pixels into y%
DO
  data$ = INPUT$((((table&(5) - 1) OR 7) + 1) \ 2, #1)
    IF (table&(5) \ 2) < LEN(data$) THEN
       linelength% = table&(5) \ 2
    ELSE
       linelength% = LEN(data$)
    END IF
    FOR x% = 1 TO linelength%
      pixel% = ASC(MID$(data$, x%, 1))
      PSET (x% * 2 + 1, y%), pixel% AND 15
      PSET (x% * 2, y%), pixel% \ 16
     NEXT
    y% = y% - 1
LOOP UNTIL EOF(1) 'OR INKEY$ <> ""
CLOSE

SLEEP
ENDer
'RUN "c:\turbo\games.bas"
END SUB

DEFINT A-Z
SUB WriteReg (Reg%, value%)
OUT BasePort% + 8, Reg%
 FOR V% = 1 TO 6
  Buf% = INP(BasePort% + 8)
 NEXT
OUT BasePort% + 9, value%
 FOR V% = 1 TO 34
  Buf% = INP(BasePort% + 9)
 NEXT
END SUB

